SUBROUTINE COMMANDLINE(menu, prefs )

!       Image Quality Measure (IQM) Program                                                                                       
!       Copyright, THE MITRE Corporation 1992 - 2007                                                                              
!       see Data Rights Notice in HELP SUBROUTINE                                                                             

! maybe sometime add option 3 for Bitfinder (would be 6 args):
! 3   imgname   hdrbytes   bpp    color-y/n   anotherImg-y/n

      USE globaldata
      
      INTEGER, INTENT(OUT) :: menu
      CHARACTER (LEN=100), INTENT(OUT) :: prefs
       
      INTEGER :: ARGC             
      CHARACTER (LEN=100) ::  ARGV, parm      
      
      ARGC = IARGC()		! arg count
          
  IF(ARGC == 1) THEN
      		CALL GETARG(1, ARGV)
      		parm = TRIM(ARGV)
      		IF(parm(1:1) == '-') THEN 	! delete any leading dash in argument
          	  	m = LEN(parm)
          	  	parm = parm(2:m)
          	ENDIF
      		IF(parm(1:1) == 'h' .OR. parm(1:1) == 'H') THEN	
       			PRINT*, ' '
       			PRINT*, 'Valid Argument Sets:'
       			PRINT*, '1     d    aux               (Concise_Out     defaultPrefs     auxdata)'   
      			PRINT*, '2     d    aux               (Verbose_Out     defaultPrefs     auxdata)'
      			PRINT*, '11   xxx   aux               (Concise+Data_Dump_Out    userPrefs    auxdata) '
       			PRINT*, '4                            (IQM information display) ' 
      			PRINT*, 'h                            (this Help display)' 
      			PRINT*, '3   imgname   hdrbytes    bpp            (determine Gray Image Format)'
      			PRINT*, ' '
      			PRINT*, 'example run:      ./iqm  1   d   auxtest' 
    			PRINT*, ' '
    			STOP
      		ELSEIF(parm(1:1) == '3') THEN
      			menu = 3
         	ELSEIF(parm(1:1) == '4') THEN
      			menu = 4
   		ELSE
      			STOP '   Invalid Argument'
      		ENDIF
      
   ELSEIF(ARGC == 3) THEN
           DO J = 2, ARGC+1	! menu number option
          	  CALL GETARG(J-1, ARGV)
          	  parm = TRIM(ARGV)
          	  IF(parm(1:1) == '-') THEN 	! delete any leading dash in argument
          	  	m = LEN(parm)
          	  	parm = parm(2:m)
          	  ENDIF
          	  
          	  IF(J == 2) THEN
           	  	m = LEN_TRIM(parm)
     			IF(m == 2) THEN
     				IF(parm(1:2) == '11') THEN
     					menu = 11
     				ELSE
     					STOP '    Invalid Argument'
     				ENDIF
     		  	ELSEIF(parm(1:1) == '1') THEN
     				menu = 1
     		  	ELSEIF(parm(1:1) == '2') THEN
     				menu = 2
     		  	ELSE
    				print*, 'parm(1:1)  ',parm(1:1)
    				STOP '   Invalid Argument'
     		  	ENDIF

          	  ELSEIF(J == 3) THEN		! preferences file
    			prefs = TRIM(parm)
    			IF(LEN_TRIM(parm) == 1) THEN  		! d is for using default prefs file
     				IF(parm(1:1) == 'd' .OR. parm(1:1) == 'D') prefs = ''
     			ENDIF
          	  ELSEIF(J == 4) THEN 		! auxdataname is global parm for aux data file
          	  	auxdataname = TRIM(parm)
         	  ENDIF
            END DO
   ELSEIF(ARGC == 4) THEN	! BitFinder, menu=3
           DO J = 2, ARGC+1	
          	  CALL GETARG(J-1, ARGV)
          	  parm = TRIM(ARGV)
          	  IF(parm(1:1) == '-') THEN 	! delete any leading dash in argument
          	  	m = LEN(parm)
          	  	parm = parm(2:m)
          	  ENDIF
          	  IF(J == 2) THEN
          	  	IF(parm(1:1) == '3') THEN
          	  		menu = 3
          	  	ELSE
          	  		STOP '   Invalid Argument'
          	  	ENDIF
      		  ELSEIF(J == 3) THEN
      		  	imgID = TRIM(parm)
      		  ELSEIF(J == 4) THEN
      		  	READ(parm, '(I8)') header      		 
      		  ELSEIF(J == 5) THEN
      		  	READ(parm, '(I4)') bpp 
      		   ENDIF	
             END DO
             PRINT*, ' '
             PRINT*, 'This is for GrayScale Image Only; use IQM double-click app for format of color image'
   ELSE
       	     STOP '   Invalid Number of Arguments (must be 1, 3, or 4)'
   END IF
  
 END SUBROUTINE COMMANDLINE
 