	MODULE	GlobalData	
	
! 	THIS MODULE DEFINES PROGRAM-WIDE CONSTANTS AND ARRAYS

	SAVE		! Absoft compilers don't appear to need 'save', but other compilers might
	
	
	
		
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
! DEFINE VALID SENSORS & COMPILER OPTIONS:

!  There are 2 valid sensor sets, partial set or total set:  			
   CHARACTER(1), PARAMETER :: allsensors = 'N' 	  
 				        !  'N'   EXCLUDES sensors 16(T1), 17(T2), 18(T3)
 					!  'Y'   INCLUDES all sensors  							
 					!   	 if 16,17,18 Included, need to uncomment print* statements					
 					!   	 pertaining to T1,T2,T3 sensors in CREATEAUX & HELP


!  Select Operating System:	
   CHARACTER(3), PARAMETER :: compiler = ' '  	! leave blank, unless/until OS-specific code is added to IQM
	  			     !   'WIN'	  Windows 
	 			     !   'OSX'	  Mac OSX
				     !   'OS9'    Mac OS9 classic		



!  Select compiled version:   double click app   or   Unix-style command line:
   CHARACTER(1), PARAMETER :: cmdline = 'N'	
 				    !   'N'    compile as "dbl click" app with menu display in Windows or Mac OSX Gui mode
				    !   'Y'    compile as command line run in Mac or Windows/Cygwin terminal mode

!  	Absoft Compile switches for Mac OSX (similar for Windows):
!		cmdline = 'Y'     Terminal Mode: Command-Line data entry: 
!		in "Set Project Options": Target Type = Terminal 
!				          check "Use UNIX Library"
!					  "Advanced Optimizations (-03)"
!				          Target Filename:  ./iqm   (./ will delete .out from final name??) 
!  			example run in terminal mode:
!			cd /xxxx	(get to folder that contains exec, images, data files)
!			./iqm.out   menu#   PrefsFileName    AuxFileName 
				
!		cmdline = 'N'     GUI Mode: Dbl-Click App with menu display: 
!		in "Set Project Options": Target Type = MRWE 
!				          uncheck "Use UNIX Library"
!					  "Advanced Optimizations (-03)"
!					  delete commandline subroutine from compiler files list
!					  comment-out:  CALL commandline()   in iqm.f95			           
		
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
		
		
		
		
	REAL, ALLOCATABLE, DIMENSION(:,:) :: power
	REAL, ALLOCATABLE, DIMENSION(:) :: DATAR	! RealImage & REAL part of FFT
	REAL, ALLOCATABLE, DIMENSION(:) :: DATAI	! Imaginary part of FFT
	REAL, ALLOCATABLE, DIMENSION(:) :: WORKR	! real work array within FFT
	REAL, ALLOCATABLE, DIMENSION(:) :: WORKI	! imaginary work array within FFT
	
	INTEGER(2), ALLOCATABLE, DIMENSION(:,:) :: image  ! for 16bpp, image range is initially assumed to be 
 							  ! -32768 to +32767, which is later changed to 0 to 65535 range
	
	INTEGER, ALLOCATABLE, DIMENSION(:) :: xcoord, ycoord, width, height, detnum, tempwidth
	INTEGER, PARAMETER :: maxsubs = 20000		! max # subimages within 1 image 
	
	INTEGER, PARAMETER :: UIMG = 1			! input imagefile (read)
	INTEGER, PARAMETER :: UTMP = 2			! internal temp file for verbose output (write/read)
	INTEGER, PARAMETER :: UDMP = 3	    		! output comma-delimited datadumpfile (write)
	INTEGER, PARAMETER :: UOUT = 4			! standard output file-concise or verbose (write)
	INTEGER, PARAMETER :: UAUX = 7	    		! input prefsfile (read), then input auxdatafile (read)
	INTEGER, PARAMETER :: UPAR = 8	    		! output file for paired image processing (write)
	INTEGER, PARAMETER :: UWRT = 10	    		! output subimage file (write)
	INTEGER, PARAMETER :: USCH = 11			! internal temp storage of comma-delimited auxdata, for transfer to datadumpfile (write/read)
	
	INTEGER :: noiseflag,  magnifyminify, totwidth, totheight, header, startbit  
	INTEGER :: minsize, maxsquare,  numrings, bpp, jsensor, jsensormode		
	INTEGER :: xlength, ylength, irotationangle, iqmnametype, nyquistring, tempminsize, tempmaxsquare
	INTEGER :: wedgecount(361), ringcount(0:250), pixelUL1, pixelUL2, pixelLL1, pixelLL2 
!		'ValidSensors' number is matched to specific sensor type in createaux.f90 
!	 	arraysize = 20 must agree with array size in createaux 
	INTEGER :: pgmImageFlag = 0	! =0 is starting assumption that order=L for all pgm images in auxdatafile
	
	INTEGER, DIMENSION(20) :: ValidSensors = (/1,2,3,4,5,6,0,0,0,0,0,0,0,0,0,16,17,18,0,0/)		! set for maximum of 20
	
	DOUBLE PRECISION :: dcpower, acpower, totpower	  ! computed in Normalize subroutine

	! establish smallest nonzero positive numbers for sngle & dble precision:
	DOUBLE PRECISION, PARAMETER :: TinyDble = 10.D0**(-RANGE(1.D0))
	REAL, PARAMETER :: TinySngl = 10.**(-RANGE(1.))
	
	REAL :: beginfreq, wedgewidth, slopecut, adjfreq, freqmin, freqmax, dcM, dcB, acM, acB, tcM, tcB
	REAL :: highdcM, highdcB, highacM, highacB, hightcM, hightcB, highnoise, highblur, highsmear
	REAL :: highhaze,  sighaze,  detectlevel,  ccdband,  spot,  viewdist
	REAL :: spikefreq, spikeangledelta, RedW, GreenW, BlueW
	REAL :: sigmaG2, sigmaS2, rapw, DenomExp, Kappa1, Kappa2
	REAL :: wedge(361), wedgeFilter(361), wedgetemp(361), ring(0:250), ringFilter(0:250), ringtemp(0:250)	    
    	REAL :: IQ    ! computed Image Quality value 
	
	CHARACTER (LEN=50), PARAMETER :: iqmversion = 'v7.3'
	CHARACTER (LEN=12), PARAMETER :: stdprefname = 'DefaultPrefs'
	CHARACTER (LEN=1) ::  lengthout, smearexists
	CHARACTER (LEN=2) ::  psntype, mcode(20), peakavg, order, SubImageInfo
    	CHARACTER (LEN=4) :: imagetype
	CHARACTER (LEN=100) ::  iqmname, prefname, imgID, auxdataname   
	
	
	END MODULE GlobalData
 
