      SUBROUTINE createaux () 
                                                                                                                                  
!       Image Quality Measure (IQM) Program                                                                                       
!     Copyright, THE MITRE Corporation 1992 - 2007                                                                               
!       see Data Rights Notice in HELP SUBROUTINE                                                                             
                                                                                                                                  
!       This subroutine:                                                                                                          
!    Constructs auxdata file from user inputs of sensor parameter values                                                          
                                                                                                                                  
      USE globaldata
	  
      REAL :: look
	  
      INTEGER, ALLOCATABLE, DIMENSION(:) :: ncol, nrow, subwidth, subheight, detnumtemp      
      
      CHARACTER(len=1) ::   chr
      CHARACTER(len=2) ::   tac
      CHARACTER(len=3) ::   mode                                                                                                                                                                                                                                               
      CHARACTER(len=7) ::   subs
      
	  ALLOCATE (ncol(maxsubs), nrow(maxsubs), subwidth(maxsubs), subheight(maxsubs), detnumtemp(maxsubs), stat=ierr)  
  	  IF(ierr /= 0) THEN
 	  		STOP '  Fatal Problem:   memory allocation failed for subimage setup'
	  ENDIF

	  OPEN (UAUX, file = auxdataname, status = 'NEW') 
      PRINT*, ' '
      PRINT*, 'AuxDataFile is created from following user inputs,'
      PRINT*, 'when done, the file can be edited off-line' 
        
      degperrad = 57.2957795                                                                                                                                                                                   
  	  
  	  
  	  
	  DO 9999 imgnum = 1, 1000 
 6111    PRINT*, ' ' 
         PRINT*, ' ' 
      	 PRINT*, 'Enter Sensor Number (or H for help):' 
         PRINT*, ' ' 
      	 PRINT*, '       1       General Aerial/Space Digital Sensor' 
      	 PRINT*, '       2       Oblique Aerial/Space Digital Sensor' 
      	 PRINT*, '       3       Aerial/Space Film Camera' 
      	 PRINT*, '       4       General Sensor'
	 PRINT*, '       5       Ground-Based Digital Camera'
!	 PRINT*, '       6       placeholder'	                                                                             
		IF(allsensors == 'Y') then
			PRINT*, '       16       T1'  
		 	PRINT*, '       17       T2'  
			PRINT*, '       18       T3'  			 
		ENDIF 
		
         READ(*,'(a)') mode
         chr = trim(adjustl(mode))
		 IF (chr=='h' .or. chr=='H') then 
              CALL help (i) 
              GOTO 6111 
         ELSE 
              READ(unit=mode, fmt='(I3)', err=6111) jsensor
              iflag = 0
			  DO i=1,20	! this range must agree with validsensors arraysize in Globaldata	
				  IF (jsensor == ValidSensors(i) ) then
					  iflag = 1
					  IF (jsensor > 15 .and. allsensors /= 'Y') iflag = 0
					  IF ((jsensor < 1) .OR. (jsensor > 5 .AND. jsensor < 16))  iflag = 0
				   ENDIF
			  END DO
         	  IF(iflag == 0) GOTO 6111
		 ENDIF 
                                                                                                                                  
 7       PRINT*, ' ' 
      	 PRINT*, 'ImageFileName:   ' 
         READ(5, fmt='(A)') imgID 
         

		 
		 CALL PGM (kflag)
		 
		 IF(kflag == 2) THEN		! image filename ends in .pgm & is readable
			bpp = 8
			order = 'L'		!  PGM file is Assumed to be 'L', but may not always be true
		 ELSEIF(kflag == 1) THEN	! image filename ends in .pgm but is not readable
		 	GOTO 9999
		 ELSE			! image is not pgm format (doesn't end in  .pgm)
2        	PRINT*, ' '
	     	PRINT*, 'HEADER_bytes,  WIDTH_pixels,  HEIGHT_pixels:' 
         	READ(5, *, err=2) header, totwidth, totheight 
8		 	PRINT*, ' '		 			 			 		 	
		 	PRINT*, 'if bpp = 8,   BitOrder = B or L'
			PRINT*, 'if bpp = 16,  BitOrder = B, L, -B, or -L'  
		 	PRINT*, ' '
		 	PRINT*, 'enter:  bpp, BitOrder'
		 	
		 	READ(5, *, err=8) bpp,order
			IF(bpp /= 8 .and. bpp /= 16) THEN
					PRINT*, 'bpp must be 8 or 16, try again'
					GOTO 8
			ENDIF
			CALL UpperCase(order)
			IF(bpp == 8 .and. order /= 'B' .and. order /= 'L') GOTO 8
			IF(bpp == 16) THEN
	 				IF(order/='-B' .and. order/='B' .and. order/='-L' .and. order/='L') GOTO 8
	 		ENDIF
		ENDIF 		
		
		subs = ''
		 PRINT*, ' '
		 PRINT*, 'RETURN          (to process entire image)'
		 PRINT*, ' or'
		 PRINT*, '#subs           (number of subimages to be processed)'
		 READ(*,fmt='(a)') subs

		
		 IF (len(trim(adjustl(subs))) == 0) THEN
		 		ncol (1) = 0 
            			nrow (1) = 0 
            			numsubs = 0 
				CALL primecheck(totwidth, iprimecheck)
		 ELSE
			READ(unit=subs, fmt=*) numsubs             
            		PRINT*, 'Reference Origin: subimage in UpperLeftCorner of entire image is at 0,0'
            		PRINT*, ' '
            		DO i = 1, numsubs 
 6499		   		PRINT*, 'for subimage #',i,' enter:'
    		   		PRINT*, '  UpperLeftCOL,   UpperLeftROW,   WidthPixels' 
               			READ(5, *, err=6499) ncol(i), nrow(i), subwidth(i)                                                                                                            
               			CALL primecheck(subwidth(i), iprimeflag)      
			   	IF(iprimeflag == 1) THEN		     
			   		PRINT*, 'want to select different subimage width?  y/n'
					READ*, chr
					IF(chr == 'y' .or. chr == 'Y') GOTO 6499
 			   	ENDIF
               			IF (((ncol(i)+subwidth(i)) > totwidth).or.((nrow(i)+subwidth(i)) >totheight)) then                                                                             
                  			PRINT*, 'Subimage goes beyond total image boundary; change col,row,or width' 
                  			GOTO 6499 
				ELSEIF(subwidth(i) > maxsquare) then
!			   	  	PRINT*, ' '   THIS IMPLIES PREFS FILE MUST BE DEFINED FIRST, PROBABLY NOT GOOD REQUIREMENT
!				  	PRINT*, 'Subimage width cannot be > maxsquare defined in Prefs file'
!				  	PRINT*, ' '
!				  	GOTO 6499
               			ENDIF 
 			subheight(i) = subwidth(i) 			
			END DO   
		 ENDIF
		 		 
                                               
                                                                                                                                                                                                                                                            
         fwdtilt = 0. 			! degrees
         sidetilt = 0. 			! degrees
         gamma = 0. 			! degrees
         reltivepsilon = 0. 	! degrees
         az = 0. 				! degrees
         look = 0. 				! degrees
         xmagmin = 1. 			! dimensionless
         jsensormode = 0 		! dimesionless
         acpitch = 0. 			! degrees (also used as general parameter name)
         acroll = 0. 			! degrees (also used as general parameter name)
         acyaw = 0. 			! degrees (also used as general parameter name)
         fl = 0. 				! inches
         gsd = 0. 				! feet
         alt = 0. 				! feet
         pixel = 0. 			! microns
         rotation = 0. 			! degrees
		 detnumtemp = 0 			! initialize array to 0 
 	     						! detnumtemp(i) is detector pixel number in center of subimage i
								! detnumtemp & numpix are zero for sensors 1 - 6
		 
         IF (magnifyminify /= 0) then 		! magnifyminify is set in IQM subroutine
            PRINT*, 'Image magnify,minify, or pixel aggregation?' 
            READ *, xmagmin 				! see Scaling subroutine for explanation of xmagmin
         ENDIF 
         IF (irotationangle /= 0) then 		! irotationangle is set in IQM subroutine
            PRINT*, 'Rotation angle of displayed image' ! is only used in sensors 16,17,18
      		PRINT*, '      (increases clockwise, 0 to 359 degrees)' 
            READ *, rotation 
         ENDIF 
                                                                                                                                  
!  ******************** general VERTICAL or min.info.OBLIQUE Aerial/Space sensor **********                                       
   11    IF (jsensor==1) then 
   10       PRINT*, ' ' 
            PRINT*, 'Enter 1, 2, or 3:' 
     	    PRINT*, '       1         GSD known' 
      	    PRINT*, '       2         Range, Focal_Length, Detector_Pixel_width known' 
     	    PRINT*, '       3         Range, Instant_Angular_Field_of_View known' 
                                                                                                                                  
            READ(5,*, err=10) jsensormode
            IF (jsensormode==1) then 
               PRINT*, 'GSD (feet)?' 
               READ *, gsd 
            ELSEIF (jsensormode==2) then 
15     		   PRINT*, 'Range(feet),  FL(inches),   pixelwidth(microns)?' 
               READ(5,*, err=15) alt, fl, pixel 
            ELSEIF (jsensormode==3) then 
16     		   PRINT*, 'Range,  Instant.FOV(milliradians)?' 
               READ(5,*, err=16) alt, reltivepsilon 
            ELSE                
               GOTO 10 
            ENDIF 
			
!  ****************** generic  OBLIQUE Aerial/Space Sensor ****************************                                           
         ELSEIF (jsensor==2) then 
17          PRINT*, ' ' 
            PRINT*, 'enter 1 or 2:' 
     	    PRINT*, '       1         if intrackGSD & crosstrackGSD known' 
      	    PRINT*, '       2         if Altitude, FocalLength, DetectorPixelWidth known' 
			READ(5,*, err=17) jsensormode 

           IF(jsensormode == 1) then
!				This GSDit & GSDct option makes some simplifying assumptions: 
!					sensor is side-looking,field angle = 0., gamma=0.
!				GSDit is stored in "gsd" parm;  GSDct is stored in "reltivepsilon" parm;
!				then in scaling routine these are converted to the needed parms: fl,alt,pixel
18				PRINT*, ' '
            	PRINT*, 'intrackGSD,  crosstrackGSD     (feet)?'
				READ(5,*, err=18) gsd, reltivepsilon
				IF(reltivepsilon < gsd) THEN
					PRINT*, ' '
					PRINT*, 'NOTE - you have entered crosstrackGSD value which is less than intrackGSD,'
					PRINT*, 'this does not usually occur;   want to re-enter GSDs?  y/n'
					READ*, ch
					IF(chr == 'y' .or. chr == 'Y') GOTO 18
				ENDIF
         	ELSEIF(jsensormode == 2) then
19		 		PRINT*, 'enter 3 parameter values:'   
      			PRINT*, 'SensorAltitude(feet), FocalLength(inches), DetectorPixelWidth(microns):' 
            	READ(5,*, err=19) alt, fl, pixel 
20            	PRINT*, ' ' 
	        	PRINT*, 'need 2 angles (g,e) in degrees: ' 
      PRINT*, '     g = |angle| between detector array length & sensor platform Xtrack line' 
      PRINT*, '         (0 to 90 degree range)'
	  PRINT*, '     e = +-field angle of image center along sensor principle line' 
      PRINT*, '        + if image center is on nadir side of optical axis' 
      PRINT*, '        - if image center is on horizon side of optical axis'        			
				PRINT*, 'enter g,e'
				READ(5,*, err=20) gamma, reltivepsilon 
21   			PRINT*, ' '
    			PRINT*, 'need set of 2 angles (0 to 90 degree range):' 
   				PRINT*, 'azimuth & look........or........forwardtilt & sidetilt '
				PRINT*, ' '
   				PRINT*, 'enter:	1, azimuth, look'
     			PRINT*, '  or' 
      			PRINT*, 'enter:	2, forwardtilt, sidetilt ' 
            	READ(5, *, err=21) nnn, a, b
            	IF (nnn==1) then 
               		az = a 
               		look = b 
            	ELSEIF (nnn==2) then 
               		fwdtilt = a 
               		sidetilt = b 
            	ELSE 
               		GOTO 21 
            	ENDIF 
		 	ELSE
				GO TO 17
			ENDIF 
				
                                                                                                                                  
! ******************* Aerial/Space Film Camera *************************                                                          
         ELSEIF (jsensor==3) THEN 
22          PRINT*, 'enter 3 values:' 
      		PRINT*, 'filmGRD(feet),  scannerPPI,   PhotoScale' 
            READ(5,*, err=22) fl, pixel, alt       ! using existing auxdata parm.names                                                   
   


         ELSEIF (jsensor==4) THEN
!               no other data needed;  cyperft = 1.  is set in Scaling subroutine         
! 		This is most General Case, Non-Aerial Camera, Terrestrial Imaging:
!                        i.e., an earthbound sensor (non-airborne, non-spaceborne) for which scale,
!                        between object plane & image plane, does not affect image quality 



! ******************* Ground-Based Digital Camera **************************
			ELSEIF (jsensor==5) THEN 
				PRINT*, 'Digital camera (color or gray) with user options:'
				PRINT*, '        Image quality does/doesnot depend on #pixels in sensor array.'
				PRINT*, '        Image quality does/doesnot depend on object-image scale.'
		 		PRINT*, ' '
				az = 0.0;   look = 0.0
!				In the other sensors, image size differences are normalized-out of computed IQ, 
!				in order to directly compare IQ results from different size images.
!				But for digital camera, number of pixels in sensor array may correlate with 
!				observed image quality, i.e., more pixels implies higher quality.
!				Following allows user to define importance of IQ--#pixels relation:
				PRINT*, 'Does image quality depend on number of pixels in sensor array?   y/n'
				READ*, chr
		 		IF(chr == 'y' .or. chr == 'Y') THEN
						PRINT*, ' enter sensor arry size in pixels:   WIDTH,  HEIGHT '
						READ*, az, look		! these parameter names are not otherwise used for sensor 5
				ENDIF						! see normalize subroutine for how az,look are used with sensor 5

12       		PRINT*, ' ' 
            		PRINT*, 'Does image quality depend on object - image scale?   y/n'
			READ*, chr
			IF(chr == 'y' .or. chr == 'Y') THEN
30			PRINT*, 'Enter 1 or 2:' 
     	    	    	PRINT*, '       1         Detector_Pixel_Width projected to scene object is Known' 
      	    	    	PRINT*, '       2         Range, Focal_Length, Detector_Pixel_Width are Known'                                                                                                                  
            		READ(5,*, err=12) jsensormode
            		IF (jsensormode==1) then 
               			PRINT*, 'enter:  Detector_Pixel_Width projected to Scene Object (feet)'
               			READ *, gsd 
            		ELSEIF (jsensormode==2) THEN 
13     		   		PRINT*, 'enter:  Range(feet),  FL(inches),   Detector_Pixel_Width(microns)' 
               			READ(5,*, err=13) alt, fl, pixel 
            		ELSE
				GOTO 30
			ENDIF
		ELSE
			jsensormode = 3		!  no further data needed in this option 
						!  cyperft = 1.  is set in Scaling subroutine  
		ENDIF			                                                                
		

! ******************* Placeholder **************************								 
!         ELSEIF (jsensor==6) THEN
		! if placing sensor case here, do search over all code for existing:   =6  &  = 6
                                                                                                                                                                                             		 		 
                                                                                                                                                                                                                                                                   
! **************** T1 *****************************                                                                             
         ELSEIF (jsensor == 16 .and. allsensors == 'Y') then 
            tac = 'T1'
                                                                                                                                  
                                                                                                                                  
! ****************  TM ***************************************                                                                  
         ELSEIF (jsensor == 17 .and. allsensors == 'Y') then 
            tac = 'T2'


!  ********************   T3 ***********************************                                                                
         ELSEIF (jsensor == 18 .and. allsensors == 'Y') then 
            tac = 'T3'
		
	 ELSE
	     GOTO 6111
		 
   ENDIF 		 
	  
	  
	  imagetype = 'GRAY' 
	  IF(jsensor < 16 .and. kflag /= 2) THEN	! if kflag=2 it is pgm image which must be gray
	  		PRINT*, 'Is this a COLOR image? y/n'
		 	READ*, chr
		 	IF(chr == 'y' .or. chr == 'Y') imagetype = 'RGB'    
	   ENDIF                                                                                                         
                                                                              
                                                                                                                                  
                                                                                                                                  
!       ************** WRITE DATA TO INPUT FILES ********************************                                               
                                                                                                                          
                                                                                                                                  
         IF (imgnum == 1) then                                                                              
	    WRITE(UAUX, *) '# Wdth_Hght_Hdr_Bpp_Ord_Cpix_FL_GSD_Alt_Pxl_Az_Lok_Fwd_Side_Gam_Ep_Ptch_Rol_Yw_Snsr_Mod_Mag'
	 ENDIF 
         WRITE (UAUX, *) trim(imgID),'        ',trim(imagetype) 
         WRITE (UAUX, *) totwidth,totheight,header,bpp,order,detnumtemp(1),fl,gsd,alt,pixel,az,look,fwdtilt,&
                           sidetilt, gamma, reltivepsilon, acpitch, acroll, acyaw, jsensor, jsensormode, xmagmin                                                                                                                                                                                             
	 
! Following with "F0.0" should be most compact write format, but with Absoft v8.0 for OSX it will only write as many
! places as are defined to right of decimal point, e.g. if user inputs 2.678, writes as 3.0 when using F0.0
! Absoft v6.2 for Mac OS9 and ???? Absoft v8.0 for Windows, do not even recognize F0.0 format
! One method, rather involved, would be to use format * write to internal file, read  file, test each parm value for  
! zero, then write it as character: '0.0' if it is zero
!         WRITE (UAUX, 555) totwidth,totheight,header,bpp,order,detnumtemp(1),fl,gsd,alt,pixel,az,look,fwdtilt,&
!                             sidetilt, gamma, reltivepsilon, acpitch, acroll, acyaw, jsensor, jsensormode, xmagmin                                                                                                                                                                        
! 555	 FORMAT(4(I0,1X),A3,1X,I0,1X,13(F0.0,1X),2(I0,1X),F0.0)
	

	IF(numsubs > 0) THEN
	   DO jk = 1, numsubs 
            IF(jsensor==16 .or. jsensor==17 .or. jsensor==18) THEN
				WRITE (UAUX, '(5(1x,I5))') ncol(jk), nrow(jk), subwidth(jk), detnumtemp(jk)                           
			ELSE
				WRITE (UAUX, '(4(1x,I5))') ncol(jk), nrow(jk), subwidth(jk)
			ENDIF
  	   END DO 
     ENDIF                                                                                                                              
       
                                                                                                                                  
         PRINT*, ' ' 
      	 PRINT*, 'Another Image?  y/n  ' 
         READ *, chr 
         IF ((chr == 'Y').or.(chr == 'y')) THEN 
            PRINT*, ' ' 
            PRINT*, ' ' 
            PRINT*, 'last image done was: ', imgID 
         ELSE
	   DEALLOCATE (ncol, nrow, subwidth, subheight, detnumtemp)
	   EXIT		! exit DO 9999
	ENDIF
		                                                                                                                             
 9999 END DO 
                                                                                                                                  
                                                                                                                                  
      WRITE (UAUX, *) '#   pound sign in column 1 or 2 implies a comment line' 
      WRITE (UAUX, *) '#   a line with only 3 or 4 data values is subimage line: ULcol, ULrow, width, nmpx' 
      WRITE (UAUX, *) '#   for details of parameters, see IQM_Guide section: Sensor Parameters & AuxDataFile'
	  PRINT*, ' ' 
      PRINT*, ' ' 
      PRINT*, 'Aux data file completed for ', imgnum, ' images' 
      PRINT*, ' ' 
                                                                                                                                  
      CLOSE (UAUX) 
       
      END SUBROUTINE createaux 
	  
	  
	
