      SUBROUTINE createprefs () 
                                                                                                                                  
!       Image Quality Measure (IQM) Program                                                                                       
!       Copyright, THE MITRE Corporation 1992 - 2007                                                                             
!       see Data Rights Notice in HELP SUBROUTINE                                                                             
                                                                                                                                  
!       This subroutine:                                                                                                          
!       Creates the IQM default preferences file                                                                                 

!	if parms are added or deleted from prefs file, should change prefs data dump accordingly
!	(see end of maincaller)

                                                                                                                                  
      USE globaldata
	  
	  CHARACTER(len=132) :: line 
      LOGICAL :: fileexists
      
     
	  INQUIRE (File = prefname, Exist = fileexists) 
      IF (fileexists) THEN
                OPEN (7, File=prefname, status='REPLACE')                                                      
      ELSE 
				OPEN (7, File=prefname, status='NEW')                                                                 
      ENDIF  

	 
	 line = '#         Preferences file for IQM  '                                                                                                                            
      	WRITE (7, fmt='(A37,A)') line, trim(iqmversion)
	
	  line = ' '
	    WRITE (7, 77) line                                                                                                        
      line = '#         To create your own prefs file: '                                                                                                                            
      	WRITE (7, 77) line
	  line = '#   		Edit IQM"s DeFaultPrefs file, rename & save.' 
      	WRITE (7, 77) line 
      line = '#         DeFaultPrefs file is created after first 2 steps in program:' 
      	WRITE (7, 77) line 
      line = '#                start IQM' 
      	WRITE (7, 77) line 
      line = '#                Enter  < 1 > ' 
      	WRITE (7, 77) line 
      line = '#                Return key' 
		WRITE (7, 77) line 
      line = '#                Return key' 
		WRITE (7, 77) line 
      line = '#                Quit program' 
		WRITE (7, 77) line 
      line = ' '
	    WRITE (7, 77) line 
	  line = '#   comment line must have pound sign (#) in column one.' 
      	WRITE (7, 77) line 
	  line = '#   data line can have trailing comments, no # needed.' 
      	WRITE (7, 77) line 
      line = '#   blank lines are OK' 
      	WRITE (7, 77) line 
      line = '#   all frequencies in cycles per pixelwidth (x-axis of power spectrum)' 
      	WRITE (7, 77) line 
      line = ' '
	  	WRITE (7, * ) line 
      line = 'iqmname = IQM_OUTPUT           Output filename' 
      	WRITE (7, 77) line 
      line = 'iqmnametype = 1         = 1 to append to existing output file,' 
      	WRITE (7, 77) line 
      line = '#                       = 0 to write over existing output file' 
      	WRITE (7, 77) line 
      line = 'psntype = DC            power spectrum normalization options: ' 
      	WRITE (7, 77) line 
      line = '#                           DC: IQ value highly dependent on image contrast (normal case)' 
      	WRITE (7, 77) line 
      line = '#                           TC: IQ value dependent on image contrast' 
      	WRITE (7, 77) line 
	  line = '#                           AC: IQ value not dependent on image contrast'     	
      	WRITE (7, 77) line 
!	  line = '#                           NB: IQ value dependent on brightness'	
!	WRITE (7,77) line  	
	  line = 'spot = 0.6              spot & viewdist are used to fix spatial frequency location of' 
      	WRITE (7, 77) line 
	  line = 'viewdist = 351.3288     peak of Human Visual System (HVS) response curve on power spectrum' 
      	WRITE (7, 77) line 
      line = '#                       292.774*spot/viewdist = peak location in cycles per pixelwidth' 
      	WRITE (7, 77) line 
	  line = 'minsize = 256           min width subimage program will find; but smaller Square images can be input'
      	WRITE (7, 77) line 
	  line = 'maxsquare = 8192        max width image processed whole (single FFT); but larger images OK' 
	    WRITE (7, 77) line
	  line = 'peakavg = P              P = peakIQ, A = avgIQ, PA = peak&avgIQ (computed if subimages exist)'
	    WRITE (7, 77) line 
	  line = 'SubImageInfo = N        N = avg of subimages info to outfile; Y = info for each subimage to outfile;'
	WRITE (7, 77) line
	      line = '#                       NW or YW = write entire image to file with boundary line around peakIQ subimage' 
      	WRITE (7, 77) line 
	  line = 'beginfreq = 0.10        lowest frequency used for wedge power' 
      	WRITE (7, 77) line 
      line = 'wedgewidth = 4.0        angular width of one wedge;   <=180 degrees' 
      	WRITE (7, 77) line 
	  line = 'slopecut = 999.         image blur if computed avg slope (0.05-0.25 frequency) > slopecut,' 
      	WRITE (7, 77) line 
      line = '#                       then IQ sum switches (if NIIRS sensor) to: adjfreq to freqmax,' 
      	WRITE (7, 77) line 
      line = '#                       slopecut=999. disables test, real working value is about 12.8'
	   WRITE (7, 77) line 
	  line = 'adjfreq = 0.10          see slopecut' 
      	WRITE (7, 77) line 
      line = 'freqmin = 0.01          0.010 is normal min frequency for IQ power summation' 
      	WRITE (7, 77) line 
      line = 'freqmax = 0.707107      0.707107 is normal max frequency for IQ power summation' 
      	WRITE (7, 77) line 
	  line = 'highblur = 80.          severe blur if highblur < computed lowfreqslope' 
      	WRITE (7, 77) line 
      line = 'highsmear = 40.         smear if highsmear < computed wedgeratio (dir.& mag. computed)' 
      	WRITE (7, 77) line 
      line = 'highhaze = 0.02         heavy haze if contrast < highhaze'
      	WRITE (7, 77) line 
      line = '#                       highhaze = -99. switches on paired image processing option'  
	    WRITE (7, 77) line 
	  line = 'sighaze = 0.07          highhaze < contrast < sighaze implies some haze present' 
      	WRITE (7, 77) line 
      line = 'ccdband = 3.            pixel banding if power@.5cy/pixwdth > ccdband*power@.45cy/pixwdth,' 
      	WRITE (7, 77) line 			
	  line = '#                       then NoiseRatio & NoiseVar computed from frequency < Nyquist'                      
	    WRITE (7, 77) line 
	  line = ' '
	  	WRITE (7, 77) line
	  line = 'dcM = 1.6092            NIIRS = dcM * Log10(IQ) + dcB,  DC normalization' 
      	WRITE (7, 77) line 
      line = 'dcB = 8.6849            ' 
      	WRITE (7, 77) line 
      line = 'acM = 2.2923            NIIRS = acM * Log10(IQ) + acB,  AC normalization' 
      	WRITE (7, 77) line 
      line = 'acB = 8.0               ' 
      	WRITE (7, 77) line 
      line = 'tcM = 1.650             NIIRS = tcM * Log10(IQ) + tcB,  TC normalization' 
      	WRITE (7, 77) line 
      line = 'tcB = 8.8745            ' 
      	WRITE (7, 77) line 
	  line = 'highdcM = 1.6092        NIIRS = highdcM * log10(IQ) + highdcB, blur&DC normalization' 
      	WRITE (7, 77) line 
      line = 'highdcB = 8.6849        ' 
      	WRITE (7, 77) line 
      line = 'highacM = 2.2923        NIIRS = highacM * Log10(IQ) + highacB, blur&AC normalization' 
      	WRITE (7, 77) line 
      line = 'highacB = 8.0           ' 
      	WRITE (7, 77) line   
      line = 'hightcM = 0.            NIIRS = hightcM * Log10(IQ) + hightcB, blur&TC normalization' 
      	WRITE (7, 77) line 
      line = 'hightcB = 0.            ' 
      	WRITE (7, 77) line   

 
      
	  line = ' '
	  	WRITE (7, 77) line
	  line = 'RedW = .21              for color image: R,G,B weights for color IQ,niirs,contrast' 
	  	WRITE (7, 77) line 
	  line = 'GreenW = .72            the 3 weights must sum to 1.000'
	  	WRITE (7, 77) line 
	  line = 'BlueW = .07'
	  	WRITE (7, 77) line 
      
	  line = ' '
	  	WRITE (7, 77) line
	  line = 'noiseflag = 0           = 0 for IQM Wiener noise filter' 
      	WRITE (7, 77) line 
      line = '#                       = 1 for user-supplied noise filter (6 parms: sigmaG2,...Kappa2)' 
      	WRITE (7, 77) line 
      line = 'detectlevel = 5.        some noise if noiseratio < detectlevel  (noise filter applied)' 
      	WRITE (7, 77) line 
	  line = 'highnoise = 1.1         severe noise if noiseratio < highnoise  (noise filter applied)'
      	WRITE (7, 77) line 
	  line = '#                       always set:  highnoise < detectlevel'
	  	WRITE (7, 77) line
	  line = 'sigmaG2 = .078          definition of 6 noise filter parms (sigmaG2,...Kappa2) is in'  
      	WRITE (7, 77) line 
      line = 'rapw = .9268            see Opt.Eng.J.:"Objective Image Quality.." 4/92,Table1,pg.820' 
      	WRITE (7, 77) line 
	  line = 'sigmaS2 = 6400.         ' 
      	WRITE (7, 77) line 
      line = 'DenomExp = 1.5          exponent in denominator of eq. 10, which = 1.5 in paper'
	    WRITE (7, 77) line
	  line = 'Kappa1 = 19.2         ' 
      	WRITE (7, 77) line 
      line = 'Kappa2 = 1.5          '                                                                                                                             
	  	WRITE (7, 77) line


!       line = 'spikefreq = 0.49        spikefreq & spikeangledelta used in previous'                                             
!       line = 'spikeangledelta = 3.    versions to delete power around ring 32'                                                                                                                                                                                       
!       line = 'magnifyminify = 0       =0  NORMAL CASE'                                                                          
!               write(7,77) line                                                                                                  
!       line = '#                       (digital images or displayed images have not been rescaled)'                              
!               write(7,77) line                                                                                                  
!       line = '#                       =1 for user input of magnification (>1) or minification value (<1)'                       
!               write(7,77) line                                                                                                  
!       line = 'irotationangle = 0      =0  NORMAL CASE'                                                                          
!               write(7,77) line                                                                                                  
!       line = '#                        (digital images or displayed images have not been rotated)'                              
!               write(7,77) line                                                                                                  
!       line = '#                       =1 for user input of rotation angle in degrees'                                           
!               write(7,77) line                                                                                                  
!       line = '#                        rotation angle increases clockwise, 0 to 359 degrees'                                    
!               write(7,77) line                                                                                                  
    
                                                                                                                                       
77 	  FORMAT  (A) 
                                                                                                                                  
      CLOSE (7) 
      END SUBROUTINE createprefs   
	  
