      SUBROUTINE help (i) 
                                                                                                                                  
!       Image Quality Measure (IQM) Program                                                                                       
!       Copyright, THE MITRE Corporation 1992 - 2007                                                                                                                                                           
                                                                                                                                  
      USE globaldata                                                                                                                            
      
      PRINT * , ' ' 
      PRINT * , ' ' 
      PRINT * , ' ' 
      PRINT * , '**********************   MITRE IQM PROGRAM NOTICE   **********************' 
      PRINT * , 'This software was produced for the U.S. Government under contracts ' 
      PRINT * , 'F19628-89-C-0001 and F19628-94-C-001 and is subject to the Rights in ' 
      PRINT * , 'Noncommercial Computer Software and Noncommercial Comptuer Software  ' 
      PRINT * , 'Documentation clause (DFARS) 252.227-7014 (June 1995).' 
      PRINT * , ' ' 
      PRINT * , '           Copyright 1992 - 2007, The MITRE Corporation' 
      PRINT * , ' ' 
      PRINT * , 'MITRE IS PROVIDING THIS SOFTWARE "AS IS" AND MAKES NO WARRANTY, EXPRESS'
      PRINT * , 'OR IMPLIED, AS TO THE ACCURACY, CAPABILITY, EFFICIENCY, MERCHANTABILITY,' 
      PRINT * , 'OR FUNCTIONING OF THIS SOFTWARE AND/OR DOCUMENTATION.  IN NO EVENT WILL' 
      PRINT * , 'MITRE BE LIABLE FOR ANY GENERAL, CONSEQUENTIAL, INDIRECT, INCIDENTAL, ' 
      PRINT * , 'EXEMPLARY, OR SPECIAL DAMAGES, EVEN IF MITRE HAS BEEN ADVISED OF THE ' 
      PRINT * , 'POSSIBILITY OF SUCH DAMAGES, IRRESPECTIVE OF THE CAUSE OF SUCH DAMAGES.' 
      PRINT * , ' ' 
      PRINT * , 'You accept this software on the condition that you indemnify and hold ' 
      PRINT * , 'harmless MITRE, its Board of Trustees, officers, agents, and employees, ' 
      PRINT * , 'from any and all liability or damages to third parties, including attorney' 
      PRINT * , 'fees, court costs, and other related costs and expenses, arising out of ' 
      PRINT * , 'your use of this software irrespective of the cause of said liability.' 
      PRINT * , ' ' 
      PRINT * , 'The export from the United States or the subsequent reexport of this' 
      PRINT * , 'software is subject to compliance with United States export control and ' 
      PRINT * , 'munitions control restrictions.  You agree that in the event you seek to ' 
      PRINT * , 'export this software, you assume full responsibility for obtaining all ' 
      PRINT * , 'necessary export licenses and approvals and for assuring compliance with ' 
      PRINT * , 'applicable reexport restrictions. ' 
      PRINT * , ' '
      PRINT * , 'Any reproduction of this software must contain this notice in its entirety.' 
      PRINT * , '****************************************************************************' 
      PRINT * , ' ' 
      PRINT * , '*******************************************************************************' 
      PRINT * , 'The executable code supplied by MITRE for Apple Macintosh and Microsoft Windows'
      PRINT * , 'platforms utilizes Absoft ProFortran-95 compilers, copyrighted by Absoft Corp.' 
      PRINT * , '*******************************************************************************'
      PRINT * , ' ' 
      PRINT * , ' ' 
      PRINT * , ' ' 
     
          
!           >>>>>>>>>>>>>>>>>>  HISTORY OF IQM  <<<<<<<<<<<<<<<<<<<<<      
!      
!   The foundation for IQM can be traced to the body of work initiated in the 1960s & 1970s on the 
!   measurement of image power spectra by coherent optical means, for applications such as
!   SAR signal processing, cloud screening, terrain-type classification, and automatic pattern
!   recognition, as well as image quality assessment.a variety of applications.  IQM derives most 
!   directly from a specific paper in that body of work:
!
!     "Scene Power Spectra: the Moment as an Image Quality Merit Factor", November 1976, 
!      N.B.Nill, Applied Optics, vol.15, pp. 2846-2854  
!
!   To fulfill a need on a government project, MITRE initiated an in-house R&D effort in
!   1989 to develop an all-digital approach to the previous optical approach for obtaining
!   image quality from power spectra.  Use of the inherent flexibility of a digital computer
!   and software programming enabled significant extensions of the basic concept to include, 
!   for example, a filter for the human visual system and a directional scale factor.  
!   MITRE delivered the first complete IQM software program to the US Air Force in January 1990.  
!   A paper documenting MITRE's IQM was published in 1992:
!
!     "Objective Image Quality Measure Derived from Digital Image Power Spectra", 
!      N.B.Nill and B.H.Bouzas, April 1992, Optical Engineering, vol.31, pp. 813-825  
!
!   Under the direction of Norman B. Nill, the initial IQM versions were programmed by 
!   Brian H. Bouzas (1989-1991), who also assisted in experimentation and reducing the theory to 
!   practice.  Some additional coding was performed (1991) by the late Barry R. Paine.  The program's  
!   original concept/design, and all MITRE enhancements, testing, experimentation, and coding since
!   1992 have been performed by N.B. Nill. 
!
!   The only IQM code segment not developed by MITRE is the FFT routine.  Three different open 
!   source FFT routines have been incorporated in different versions of IQM; each required additional
!   coding to reformat the 'scrambled' FFT output into a usable form.
!
!   A MITRE copyright on the IQM software program was formally applied for and granted by the 
!   Library of Congress Copyright Office in 1992.
    
 
      
      PRINT * , ' ' 
      PRINT * , ' ' 
      PRINT * , ' ' 
	  PRINT * , '***************************** HELP INFO ************************************' 
	  PRINT * , 'INITIAL DISPLAY:'
	  PRINT * , '1   run IQM, concise output.......1 line per image' 
	  PRINT * , '11  run IQM, concise output + separate DataDumpFile'  
          PRINT * , '2   run IQM, verbose output.......3 pages per image, includes plots' 
	  PRINT * , '3   determine image format........finds "order" parameter needed to read image'
	  PRINT * , '                                  into IQM (unless pgm image);'
	  PRINT * , '                                  User must know 5 image parameters (unless pgm):'
	  PRINT * , '                                  order (-B, B, -L, or L)'
	  PRINT * , '                                  bits per pixel (8 or 16)'
	  PRINT * , '                                  image header size ("offset") in bytes'
	  PRINT * , '                                  image width & height in pixels'
	  PRINT * , '4   Help & Info...................this display' 
          PRINT * , ' '
	  PRINT * , ' ' 
	  PRINT * , 'PREFERENCES data file:' 
	  PRINT * , '       program self-generates a general purpose default file, "DefaultPrefs",'
	  PRINT * , '       which can be used as is, or edited by user; this file is created'
	  PRINT * , '       immediately after 2nd step in user-input to program'
	  PRINT * , 'AUXDATA data file:' 
	  PRINT * , '        support data file of image format & sensor information'
	  PRINT * , '        created from user key-in data during IQM run;'
	  PRINT * , '        for subimage coordinates entry, reference origin is 0,0 not 1,1'
	  PRINT * , 'BATCH PROCESSING:'
	  PRINT * , '       single IQM run with many images, without repeated manual data key-in.'
	  PRINT * , '       e.g., 10,000 same-size images, all sensor #4, same preferences file:'
	  PRINT * , '       Run IQM on first image, key-in data to construct AuxDataFile.'
	  PRINT * , '       Edit AuxDataFile, or use separate file-create program, to duplicate'
	  PRINT * , '       first image AuxData for other 9,999 images (just change image filenames).'
	  PRINT * , '       Result: single AuxDataFile runs all 10,000 images in single IQM run.'
	  PRINT * , ' '
	  PRINT * , ' '
	  PRINT * , 'IMAGE TYPES: '
	  PRINT * , 'With one exception, all images are read as "raw", so user must supply image info:'
	  PRINT * , '     Headersize_bytes, Width & Height_pixels, bitsperpixel, polarity(byte order)'	  
	  PRINT * , '     Exception: PGM format images are read directly'
	  PRINT * , ' '
	  PRINT * , 'Two types of COLOR IMAGES can be Processed:'
	  PRINT * , ' (1) Three color layers are intermingled: R1,G1,B1,R2,G2,B2,...Rn,Gn,Bn'
	  PRINT * , '     e.g., TIFF "chunky" RGB format'
	  PRINT * , '     all 3 layers are run together as single image'
	  PRINT * , '    "RGB" must appear after imagefilename in AuxDataFile'
	  PRINT * , '    '
	  PRINT * , ' (2) Color layers are seqential: R1,..Rn,G1,..Gn,B1,..Bn'
	  PRINT * , '     each layer is run as separate gray image, so headerbytes in'
	  PRINT * , '     AuxDataFile must tell program where each layer starts:'
	  PRINT * , '          1stlayer image: true hdrbytes'
	  PRINT * , '          2ndlayer image: true hdrbytes + imagewidth * imageheight'
	  PRINT * , '          3rdlayer image: true hdrbytes + 2 * imagewidth * imageheight'  
	  PRINT * , '          nthlayer image: true hdrbytes + (n-1) * imagewidth * imageheight'
	  PRINT * , '     "GRAY" must appear after imagefilename in AuxDataFile'
	  PRINT * , ' '     
	  PRINT * , ' '
	  PRINT * , 'SENSOR TYPES:' 
	  PRINT * , '1,2,3  for image sensor in aircraft or satellite, imaging ground objects.' 
      	  PRINT * , '     1       General digital air/space sensor.' 
          PRINT * , '               (also use for SAR sensor, substitute IPR for GSD)'
	  PRINT * , ' '
	  PRINT * , '     2       Oblique digital air/space sensor,  ' 
          PRINT * , '               (use only if all required info is known, otherwise use case 1.' 
          PRINT * , ' '
	  PRINT * , '     3       Digitized air/space film camera imagery.' 
          PRINT * , ' ' 
          PRINT * , '     4       General case sensor: non-airborne, non-spaceborne,' 
          PRINT * , '             (medical, pictorial, fingerprints, compression studies, etc.)'
          PRINT * , '             This case assumes image quality is not affected by'
	  PRINT * , '             object-image scale; NIIRS is not computed.' 
	  PRINT * , '  '
	  PRINT * , '     5       Ground-based digital camera'
	  PRINT * , '             User option to make quality a function of sensor array size'
	  PRINT * , '             and/or object-image scale; NIIRS is not computed.'
	  PRINT * , '  ' 
!	  PRINT * , '     6       placeholder'
	  PRINT * , ' ' 
	  PRINT * , ' '
	  PRINT * , 'DEFINITIONS:' 
          PRINT * , 'Vertical sensor: optical axis is aircraft/satellite-to-ground plumb line. '
	  PRINT * , 'Oblique sensor: optical axis points to imaged ground object and this line' 
	  PRINT * , '                is not the aircraft/satellite-to-ground plumb line.'
	  PRINT * , 'GSD    = ground sample distance (feet)' 
          PRINT * , '         (width of 1 sensor detector element projected to ground)' 
          PRINT * , 'GRD    = ground resolved distance (feet)' 
          PRINT * , '         (ground width of narrowest target bar+space resolved on film)' 
          PRINT * , 'IPR    = width of 1 resolution cell of SAR sensor, projected to ground (feet)' 
          PRINT * , 'IFOV   = Instantaneous angular field of view (milliradians)' 
          PRINT * , '         (viewing angle subtended by 1 sensor detector element)' 
          PRINT * , 'PPI    = pixels per inch of film digitizer = 1/(scan spot diameter or width)' 
          PRINT * , 'PhotoScale = CameraAltitude/{FocalLength*cosine(LookAngle)}' 
          PRINT * , 'Range      = Altitude in feet (for vertical view)' 
          PRINT * , 'Range      = Sensor to Ground Object Slant Range in feet (for oblique view)' 
          PRINT * , 'Azimuth    = angle between aircraft crosstrack line and' 
          PRINT * , '             ground projection of sensor look direction' 
          PRINT * , 'LookAngle   = angle between nadir plumb line & sensor optical axis' 
          PRINT * , 'Forwardtilt = angle between nadir plumb line & look angle component'
	  PRINT * , '              in flight direction' 
          PRINT * , 'Sidetilt    = angle between nadir plumb line & look angle component ' 
          PRINT * , '              in crosstrack direction'
	  PRINT * , 'All angles are absolute value in degrees, except IFOV in milliradians.' 
          PRINT * , 'Azimuth, LookAngle, Forwardtilt, Sidetilt angles range from 0 to 90 degrees. ' 
	  PRINT * , ' '
	  PRINT * , ' '	    
	  PRINT * , ' Image Pairs Assessment Option:  use when quality difference between different'
	  PRINT * , ' versions of the same image is wanted, e.g. sharp & blurry images of same scene;'  
	  PRINT * , ' details in IQM_Guide, section: "Special Case - Paired Image Assessment".' 
	  PRINT * , ' '
	  PRINT * , ' '
	  PRINT * , '>>>>>>>>>>>  See IQM_Guide document for more details on all of above  <<<<<<<<<<<<<'
          PRINT * , ' ' 
          PRINT * , ' ' 
	  
	  IF(allsensors /= 'Y') RETURN
	  
	  ! PRINT * , ' ' 
          ! PRINT * , ' ' 
          ! PRINT * , ' ' 
	END SUBROUTINE help   
	
     