!       Image Quality Measure (IQM) Program
!       Copyright, THE MITRE Corporation 1992 - 2007
!	see Data Rights Notice in HELP SUBROUTINE	


!       This is Initial Entry Point to IQM:                                                                                              
!		Displays logo & version                                                                                        
!               Creates default preferences file                                                                               
!               Reads parameter values from prefs file & passes them to MainCaller                                       

     
     
      PROGRAM IQM     
                                                                                                                                  
      USE GlobalData
      
      CHARACTER(LEN=100) ::  ch 
      LOGICAL :: fileexists 
                                                                                                                                  
        
      IF(cmdline == 'N') THEN 
      		DO i = 1,20; PRINT *, ' '; END DO
      		PRINT * , '*-------------------------------------------------------*' 
      		PRINT * , '|          MITRE IMAGE QUALITY MEASURE (IQM)            |' 
      		PRINT * , '|                                                       |' 
     	 	PRINT * , '                  ',iqmversion
      		PRINT * , '|                                                       |'
      		PRINT * , '*-------------------------------------------------------*' 
                                                                                                   
      		DO i = 1,8; PRINT *, ' '; END DO 	                                                
                                                                                                                                       
 5    		PRINT *, ' '                                                                                                                                      
      		PRINT * , ' Enter number:'   
      		PRINT * , '     1         CONCISE Output' 
      		PRINT * , '     11        CONCISE Output with Data Dump File'
      		PRINT * , '     2         VERBOSE Output'
      		PRINT * , '     3         Determine Image Format (only)'    
      		PRINT *,  '     4         Help & Info'
      		READ*, menu
       ELSE
!       		CALL COMMANDLINE(menu, ch)
       ENDIF
       
      	IF(menu == 4) THEN
      		CALL help()
		STOP	
      	
      	ELSEIF(menu == 3) THEN
      		CALL bitfinder()
      		STOP
     
        ELSEIF(menu==1 .OR. menu==11 .OR. menu==2) THEN		
		IF(menu==1) lengthout = 'C'	! concise out
		IF(menu==2) lengthout = 'V'	! verbose out
		IF(menu==11) THEN
			lengthout = 'D'		! concise out + comma-delimited datadump out
			OPEN(USCH, status = 'SCRATCH') 
		ENDIF
		
		IF(cmdline == 'N') THEN
			print*, ' '
			print*, ' RETURN key            (will use Default Preferences file)'
			print*, '   or'
			print*, 'type filename          (User Preferences file)'
      			READ(5, fmt='(a)') ch
		ENDIF
		
		IF (LEN_TRIM(ADJUSTL(ch)) == 0) THEN
			prefname = stdprefname
	 		CALL createprefs (prefname)
		ELSE
			prefname =TRIM(ch) 
         		INQUIRE (file = prefname, exist = fileexists) 
         		IF (.NOT. fileexists) THEN 
         			STOP 'Cannot Find Preferences File'  	
    			ENDIF   
        	ENDIF
        ELSE
	  	STOP 'Wrong Menu Number'
	ENDIF
      
       OPEN (7, file = prefname, action = 'READ') 
      
                                                                                                                                  
!       READ PREFERENCES FILE PARAMETER VALUES                                                                            
!       subroutine find(parm,n,in,re,ch):                                                                                         
!                       n = 1      parm is integer, return "in"                                                              
!                       n = 2      parm is real, return "re"                                                                 
!                       n = 3      parm is char, return "ch"                                                                 
      iflag = 0 
      magnifyminify = 0      ! if not = 0, then user is asked to input magmin value in createaux 
      irotationangle = 0     ! if not = 0, then user is asked to input rotation value in createaux 
      			     ! magmin can apply to any sensor but rotation only used in sensors 16,17,18
      spikefreq = .49 
      spikeangledelta = 3.
      numrings = 32 		! number of power rings
      smearexists = 'n'
      
      
      CALL find ('beginfreq', 2, in, re, ch, iflag) 
      	beginfreq = re 
      CALL find ('wedgewidth', 2, in, re, ch, iflag) 
      	wedgewidth = re 
      CALL find ('slopecut', 2, in, re, ch, iflag) 
      	slopecut = re 
      CALL find ('adjfreq', 2, in, re, ch, iflag) 
      	adjfreq = re 
      CALL find ('freqmin', 2, in, re, ch, iflag) 
      	freqmin = re 
      CALL find ('freqmax', 2, in, re, ch, iflag) 
      	freqmax = re 

      CALL find ('dcM', 2, in, re, ch, iflag) 		! IQ-to-NIIRS slope & intercept
      	dcM = re 
      CALL find ('dcB', 2, in, re, ch, iflag) 
      	dcB = re 
      CALL find ('acM', 2, in, re, ch, iflag) 
      	acM = re 
      CALL find ('acB', 2, in, re, ch, iflag) 
      	acB = re 
      CALL find ('tcM', 2, in, re, ch, iflag) 
      	tcM = re 
      CALL find ('tcB', 2, in, re, ch, iflag) 
      	tcB = re 
      CALL find ('highdcM', 2, in, re, ch, iflag) 
      	highdcM = re 
      CALL find ('highdcB', 2, in, re, ch, iflag) 
      	highdcB = re 
      CALL find ('highacM', 2, in, re, ch, iflag) 
      	highacM = re 
      CALL find ('highacB', 2, in, re, ch, iflag) 
      	highacB = re 
      CALL find ('hightcM', 2, in, re, ch, iflag) 
      	hightcM = re 
      CALL find ('hightcB', 2, in, re, ch, iflag) 
      	hightcB = re 
      
      CALL find ('highblur', 2, in, re, ch, iflag) 
      	highblur = re 
      CALL find ('highsmear', 2, in, re, ch, iflag) 
      	highsmear = re 
      CALL find ('highhaze', 2, in, re, ch, iflag) 
      	highhaze = re 
      CALL find ('sighaze', 2, in, re, ch, iflag) 
      	sighaze = re 
      CALL find ('ccdband', 2, in, re, ch, iflag) 
      	ccdband = re 
      CALL find ('spot', 2, in, re, ch, iflag) 
      	spot = re 
      CALL find ('viewdist', 2, in, re, ch, iflag) 
      	viewdist = re 
      
      CALL find ('psntype', 3, in, re, ch, iflag) 
      CALL UpperCase(ch) 
      IF(ch(1:2) /= 'AC' .AND. ch(1:2) /= 'DC' .AND. ch(1:2) /= 'TC') STOP 'Wrong Value for psntype in Preferences file'
      psntype = ch                                                                                          
      
      CALL find ('SubImageInfo', 3, in, re, ch, iflag) 
      CALL UpperCase(ch)
      IF(ch(1:1) /= 'N' .AND. ch(1:1) /= 'Y') STOP 'Wrong Value for SubImageInfo in Preferences file'
      SubImageInfo = ch  
      
      CALL find ('peakavg', 3, in, re, ch, iflag) 
      CALL UpperCase(ch)
      IF(ch(1:1) /= 'A' .AND. ch(1:1) /= 'P') STOP 'Wrong Value for peakavg in Preferences file'
      IF(LEN(TRIM(ch))==2 .AND. ch(1:2) /= 'PA')  STOP 'Wrong Value for peakavg in Preferences file'
      peakavg = ch 
      
      CALL find ('minsize', 1, in, re, ch, iflag) 	! wanted to change minsize,maxsquare to minwidth,maxwidth
      	minsize = in 					! but ANY change in parameter names in prefs file means the
      	tempminsize = minsize				! new prefsfile wont be compatible with older iqm versions, so no change
      CALL find ('maxsquare', 1, in, re, ch, iflag) 	
      	maxsquare = in 					
        tempmaxsquare = maxsquare
      CALL find ('iqmname', 3, in, re, ch, iflag) 
      	iqmname = ch 
      CALL find ('iqmnametype', 1, in, re, ch, iflag) 
      	iqmnametype = in 
     
      CALL find ('RedW', 2, in, re, ch, iflag) 		! color weights for RGB color image
      	RedW = re 
      CALL find ('GreenW', 2, in, re, ch, iflag) 
      	GreenW = re 
      CALL find ('BlueW', 2, in, re, ch, iflag) 
      	BlueW = re   
      
      CALL find ('detectlevel', 2, in, re, ch, iflag)  	! all noise parms
      	detectlevel = re 
      CALL find ('noiseflag', 1, in, re, ch, iflag) 
      	noiseflag = in 
      CALL find ('highnoise', 2, in, re, ch, iflag) 
      	highnoise = re 
      CALL find ('sigmaG2', 2, in, re, ch, iflag) 
      	sigmaG2 = re 
      CALL find ('rapw', 2, in, re, ch, iflag) 
      	rapw = re 
      CALL find ('sigmaS2', 2, in, re, ch, iflag) 
      	sigmaS2 = re 
      CALL find ('DenomExp', 2, in, re, ch, iflag) 
      	DenomExp = re 
      CALL find ('Kappa1', 2, in, re, ch, iflag) 
      	Kappa1 = re 
      CALL find ('Kappa2', 2, in, re, ch, iflag) 
      	Kappa2 = re 
      
     
!     CALL find('numrings', 1,in,re,ch)
!	  numrings = in
!     CALL find('magnifyminify',1,in,re,ch)                                                                                    
!        magnifyminify=in                                                                                                       
!     CALL find('irotationangle',1,in,re,ch)                                                                                   
!        irotationangle=in              
     
       
      CLOSE (7) 


      IF (freqmin < 0. .or. freqmax > .707107 .or. freqmax <= freqmin ) THEN 
      	 STOP 'Fatal problem:  invalid value for freqmin or freqmax in prefs file' 
      ENDIF 
                                                                                                                                  
      IF (iflag == 1) then 
         PRINT*, 'FATAL PROBLEM WITH PREFERENCES FILE:  ' 
         PRINT*, '  Possibly using PrefsFile generated from earlier version of IQM,'
	 	 PRINT*, '  Try generating new DeFaultPrefs file using your current IQM version:'
	 	 PRINT*, '     run first 2 steps of IQM, then quit, DeFaultPrefs file is created,'
	 	 PRINT*, '     then edit or add to default values as needed.' 
         STOP 
      ENDIF 
                                                                                                                                  
       
   
  ! ********* Determine if Auxdata file exists, if not, create it from user inputs:                                                 
      	IF(cmdline == 'N') THEN
      		PRINT * , ' ' 
      		PRINT * , ' '
		PRINT * , 'Auxdata Filename          (program creates this file if nonexistent)' 
      		READ(5, fmt='(A)') auxdataname 
      		PRINT * , ' '
	ENDIF
	INQUIRE (file = auxdataname, exist = fileexists) 
      	IF (.NOT.fileexists) THEN   ! or?  IF(fileexists /= .TRUE.) 
      		IF(cmdline == 'N') THEN
      			CALL CREATEAUX ()
      		ELSE
      			STOP 'Cannot Find Aux Data File'
      		ENDIF
      	ENDIF
	OPEN (UAUX, file = auxdataname, action = 'READ') 
 
 
 
 
        ALLOCATE (xcoord(maxsubs), ycoord(maxsubs), width(maxsubs), height(maxsubs), &
     		   detnum(maxsubs), tempwidth(maxsubs), stat=ierr)
 	IF(ierr /= 0) THEN
 	  	STOP ' Fatal Problem:   memory allocation failed for subimage setup'
	ENDIF
       
                                                                                                                                
      CALL MAINCALLER ()                      
                                                                                                                                  
     
      DEALLOCATE (xcoord, ycoord, width, height, detnum, tempwidth)
  
     
      PRINT * , '       Finished run, output file is: ', iqmname 
      PAUSE
      
      
      END PROGRAM IQM                               
                                                                                                                                  
              
              
                                                                                                                                  
                                                                                                                                  
      SUBROUTINE find (parm, itype, in, re, ch, iflag) 
                                                                                                                                  
      CHARACTER (LEN=*) parm 
      CHARACTER (LEN=40) line, txt, fileparm
      CHARACTER (LEN=100)  ch                                                                                                                          
      
      REWIND (7) 
                                                                                                                                  
      parm = trim (parm) 
      CALL uppercase (parm) 
      LL = len (parm) 
10    READ (7, fmt = '(a)', end = 250) line 
      IF (line (1:1)  == '#') goto 10 
      fileparm = line (1:LL) 
      CALL uppercase (fileparm) 
      IF (fileparm == parm) then 
         IF (line (LL + 1:LL + 1)  == '=') nn = 2 
         IF (line (LL + 2:LL + 2)  == '=') nn = 3 
         txt = line ( (LL + nn) : (LL + 13 + nn) ) 
         IF (itype == 1) read (txt, *, err = 250) in 
         IF (itype == 2) read (txt, *, err = 250) re 
         IF (itype == 3) read (txt, *, err = 250) ch 
      ELSE 
         GOTO 10 
      ENDIF 
      RETURN 
                                                                                                                                  
250   PRINT * , 'Not found in preferences file:   ', parm 
      iflag = 1 
                                                                                                                                  
      RETURN 
      END SUBROUTINE find 
      
