      SUBROUTINE output(noiseratio, noisevar, contrast, avgslope, xlowfreqslope, wedgeratio, &   		                
             	        prediirs, xc, yc, xmagmin, ringwidth, imagenumber, avgGray, xMval, xBval, &         
     	      	        num, numsubsfinal, gsd, smeardir, smearmag, acpitch, layer)                                                                              
                                                                                                                                  
                                                                                                                                  
!       Image Quality Measure (IQM) Program                                                                                       
!       Copyright, THE MITRE Corporation 1992 - 2007                                                                                
!       see Data Rights Notice in HELP SUBROUTINE                                                                             
                                                                                                                                  
!       This subroutine:                                                                                                          
! *** First applies tests to determine presence of haze, blur, smear, noise, and                                                  
! *** ccd banding; the option to adjust niirs, if any of these degradations are present,
! *** has been disengaged (commented-out) since 1998.                                          
! *** Output is either in Concise or Verbose output format.
! *** Some additional Output is at end of MainCaller subroutine.
! *** Computes niirs from IQ-to-niirs slope & intercept.                                                                                                                                                                           
! *** In order to output only valid data for the 1-D                                                                              
! *** spectra, the following formulas are used to determine the number of                                                         
! *** frequency bands used:                                                                                                       
! ***                                                                                                                             
! ***     number_of_bands = int[(maxradius - offset_from_origin) / ringwidth] + 1                                                 
! ***                                                                                                                             
! ***     maxradius = sqrt[(xlength/2)^2 + (ylength/2)^2]                                                                         
! ***                                                                                                                             
! ***     offset_from_origin = first_centervalue - (ringwidth/2)                                                                  
! ***                                                                                                                             
! ***     first_centervalue = int[1 + (ringwidth/2)]                                                                              
! 		num = subimage number

 
 
                                                                                                                                  
      USE globaldata
     
	  
        REAL :: noiseratio, noisevar
      
	INTEGER :: xc, yc, firstcentervalue, values(8) 
      
	CHARACTER(len=11) ::	allcodes, runinfo 
	CHARACTER(len=10) :: 	time
	CHARACTER(len=8) ::	date
	CHARACTER(len=7) ::	layer
	CHARACTER(len=5) ::	zone                                                                                         
	  
	LOGICAL fileexists 
                                                                                                                                  
                                                                                                                                                                                                                                                          
      IF (psntype == 'DC') THEN
           xMval = dcM 
           xBval = dcB 
      ELSEIF(psntype == 'AC') THEN 
           xMval = acM 
           xBval = acB 
      ELSEIF(psntype == 'TC') THEN 
           xMval = tcM 
           xBval = tcB 
	  ELSE
	 		STOP 'Quitting, psntype in prefs file must = DC, AC, or TC'
	  ENDIF 
      prediirs = xMval * LOG10 (IQ) + xBval 

!     IQ = IQ/0.3048 		! converts IQ units from cy/groundfoot to cy/groundmeter                                                                                                                           
				! CAUTION: if changed to cy/groundmeter, must also change M & B 
				! (in prefs file) for correct IQ-to-niirs conversion  
							
!   When first image is processed:                                                                               
    IF (imagenumber == 1 .and. num == 1) THEN 	
    	   ! Open standard  output file & write basic info to it:
             INQUIRE (File = iqmname, Exist = fileexists) 
	     IF (fileexists) THEN 
                	IF (iqmnametype == 0) THEN 
                     		OPEN (UOUT, File=iqmname, status='REPLACE')  ! write over existing output file       
                	ELSE 
                     		OPEN (UOUT, File=iqmname, status='OLD', position='APPEND')  ! append to output file                                                
                	ENDIF 
             ELSE 
		     	OPEN (UOUT, File=iqmname, status='NEW')        ! create new output file                                                            
             ENDIF  
	     
	     IF(lengthout == 'V')  OPEN(UTMP, status = 'SCRATCH')   
             CALL DATE_AND_TIME(date,time,zone,values)	
     	     WRITE(UOUT,*) CHAR(12)
      	     
      	     IF(compiler == 'OSX') THEN
      			runinfo = 'MacOSX'
      	     ELSEIF(compiler == 'OS9') THEN
      			runinfo = 'MacOS9'
      	     ELSEIF(compiler == 'WIN') THEN
      			runinfo = 'Windows'
      	     ELSE
      	                runinfo = ' '
      	     ENDIF	      
	     
	     WRITE (UOUT,2)  values(2), values(3), values(1), values(5), values(6), values(7), TRIM(iqmversion), runinfo	   
2            FORMAT(//,'mdy: ',I2,'/',I2,'/',I4,'     hms: ',I2,':',I2,':',I2,'      IQM ',A,4x,A)
	     WRITE(UOUT, *)  'normalization = ', psntype           
	     WRITE(UOUT, *) 'NIIRS = ', xMval, ' *log(IQ) + ', xBval, '    (NIIRS is not applicable to sensors 4, 5, 6)'    	   
	     WRITE(UOUT, *) 	'prefs data file:  ', trim(prefname)       	   
	     WRITE(UOUT, *) 	'aux data file:   ', trim(auxdataname)   
	     
	     IF(highblur < -98.) THEN
		   	WRITE(UOUT, *) 'Image power spectrum was divided by square of user-defined MTF,prior to computing IQ'
		   	PRINT*, 'Image power spectrum was divided by square of user-defined MTF, prior to computing IQ'	
	     ENDIF
	     WRITE(UOUT, 59) 		  
59 	     FORMAT(/,'....IQ........NIIRS...Codes.....Contrast..AvgGry..Width....Col...Row..Sensr.bpp......pixel1',/)	   
      
      
             IF(lengthout == 'D') THEN		! Open dataDumpFile & Write header data to it
                INQUIRE (File = 'iqmDataDump', Exist = fileexists) 
	        IF (fileexists) THEN 
                       	IF(iqmnametype==0) THEN
                       		OPEN(UDMP, File='iqmDataDump', status='REPLACE')
                       	ELSE
                       		OPEN (UDMP, File='iqmDataDump', status='OLD', position='APPEND') 
                       	ENDIF                                               
                ELSE 
		       	OPEN (UDMP, File='iqmDataDump', status='NEW')                                                                
                ENDIF  
	        WRITE (UDMP, *) 'mt,dy,yr,hr,min,sec,nrm,Nslp,Ncpt,ver,OS,Prefsfile,Auxfile'
	        WRITE (UDMP, *)  values(2),',', values(3),',', values(1),',', values(5),',', values(6),',', values(7),',',&
	                         psntype,',',xMval,',',xBval,',',TRIM(iqmversion),',',TRIM(runinfo),',',&
	                         TRIM(prefname),',',TRIM(auxdataname)
	        WRITE(UDMP, *)
	        WRITE (UDMP, *) 'IQ,NRS,code,con,avg,wdth,col,row,snsr,bpp,imgtyp,pix1gry,imgfile,-999=DoesNotApply'
	     ENDIF
      ENDIF 
                                                                                                                                  
                                                                                                                          
                                                                                                                                  
! *** TESTS FOR SIGNIFICANTLY OR SEVERELY DEGRADED IMAGES                                                                        
! *** Currently commented-out:  If multiple degradations found, prediirs is deweighted by each degradation.                                                       
! *** mcode(6,7,8) are defined in subroutine wiener                                                                               
! *** Threshold values in these tests (e.g., highblur) are independent of power spectrum divisor 
!	  (psntype in prefsfile: AC,DC, or TC) because divisor cancels-out during test parm computation

      IF (xlowfreqslope > highblur .and. highblur > 0.) THEN 
!          deweight normal prediirs if severe blur:                                                         
!          prediirs = prediirs*exp(-.07*(xlowfreqslope-highblur))                                                                 
           mcode (2) = '2' 
!          print*,'(probable severe blur)'                                                                                        
     
!         note: if jsensor = 4, 5, 6 (non-NIIRS sensors), prediirs is set =0 in this subroutine
!         AND IQ summation range remains constant,
!         regardless of values of avgslope vs. slopecut - see HVS subroutine

	  ELSEIF (avgslope > slopecut) THEN 
           IF (psntype == 'DC') THEN 
                prediirs = highdcM * LOG10 (IQ) + highdcB 
           ELSEIF(psntype == 'AC') THEN 
                prediirs = highacM * LOG10 (IQ) + highacB 
           ELSE
                prediirs = hightcM * LOG10 (IQ) + hightcB 
		   ENDIF 
           mcode (1) = '1' 
!               print*,'(probable blur)'                                                                                          
      ENDIF 
                                                                                                                                  
                                                                                                                                  
!       if(trim(mcode(8)) == '8') print*,'(possible sensor pixel banding)'                                                        
      IF ( (contrast <= sighaze) .and. (contrast > highhaze) ) then 
!               print*,'(probable haze)'                                                                                          
      ELSEIF (contrast <= highhaze) then 
!          prediirs = prediirs*contrast/highhaze                                                                                  
           mcode (3) = '3' 
!          print*,'(probable severe haze)'                                                                                        
      ENDIF 
                                                                                                                                  
      IF (wedgeratio > highsmear) then 
!          prediirs = prediirs*(wedgeratio-550.)/(highsmear-550.)                                                                 
!          print*,'(probable severe 1-D smear)'                                                                                   
           mcode (4) = '4'
		   smearexists = 'y'
      ENDIF 
                                                                                                                                  
!       if((noiseratio < detectlevel).and.(noiseratio > highnoise)) print*, '(probable noise)'                                  
      IF (noiseratio <= highnoise) then 
!          prediirs = prediirs*(noiseratio-1.)/(highnoise-1.)                                                                     
           mcode (5) = '5' 
!          print*,'(probable severe noise)'                                                                                       
      ENDIF 
                                                                                                                                  
      IF (prediirs < 0.0) prediirs = 0.0 
                                                                                                                               
                                                                                                                                  
                                                                                                                                  
! ***  Assemble together all degradation codes detected:                                                                          
      allcodes = ' ' 
      DO i = 1, 20 
           IF (trim (mcode (i) )  /= '0') then 
                allcodes = trim (allcodes) //' '//trim (mcode (i) ) 
           ENDIF 
      END DO 
      
      
! PRINT TO DISPLAY:      
    IF(num < 2) THEN 	 ! only print info to display for first submimage, or main image                                                                                                                                                                                                                        
       IF (jsensor /= 4 .AND. jsensor /= 5 .AND. jsensor /= 6) then 
      		PRINT * , ' NIIRS=', prediirs, '  pixels:',pixelUL1,pixelUL2,pixelLL1,pixelLL2,'  ', ADJUSTL(imgID) 
!		PRINT * , ' '
       ELSE 
      		prediirs = 0.
		PRINT * , ' IQ=', IQ, '  pixels:',pixelUL1,pixelUL2,pixelLL1,pixelLL2,'  ', ADJUSTL(imgID) 
!		PRINT * , ' '
       ENDIF 
    ENDIF                                                                                                                               
  
  
              
                                                                                                                                  
! WRITE TO OUTPUT FILE - CONCISE MODE:  
   IF((numsubsfinal == 1 .OR. SubImageInfo(1:1) == 'Y')  &
   	 .OR. (numsubsfinal> 1 .AND. SubImageInfo(1:1) == 'Y')) THEN 
	 IF (jsensor /= 4 .AND. jsensor /= 5 .AND. jsensor /= 6) THEN 
             WRITE (UOUT, 500) IQ, prediirs,allcodes,contrast,avgGray, xlength, xc, yc,jsensor,bpp,layer,pixelUL1,imgID 		   
500 	     FORMAT (E13.6,1x,F6.2,2x,A7,2x,F8.5,F8.1,3I7,2x,I2,4x,I2,1x,A6,I5,2x,A) 
	  ELSE  
             WRITE (UOUT, 501) IQ, allcodes, contrast, avgGray, xlength, xc, yc, jsensor,bpp,layer,pixelUL1,imgID 		   
501 	     FORMAT (E13.6,9x,A7,2x,F8.5,F8.1,3I7,2x,I2,4x,I2,1x,A6,I5,2x,A)  
	  ENDIF 
	  
!         IF(wedgeratio > highsmear) WRITE(UOUT,502) smeardir, smearmag, imgID
! 502     FORMAT(26x,'smeardirection= ',F6.2, 5x,'smearmagnitude= ',F6.2,3x,A)
    
  	  IF(lengthout == 'D') THEN       
	        IF(jsensor==4 .or. jsensor==5 .or. jsensor==6) prediirs = -999.
	  	WRITE(UDMP,*) IQ,',', prediirs,',', allcodes,',', contrast,',',avgGray,',', xlength,',', &
	  	              xc,',', yc,',',jsensor,',',bpp,',',layer,',',pixelUL1,',',imgID 	 
	  ENDIF
   ENDIF 
    
    
   IF(lengthout == 'C' .or. lengthout == 'D') RETURN                                                                                                                                    
       
	       	   	   
		                                                                                                                          
! WRITE TO OUTPUT FILE - VERBOSE MODE:                                                                                                             	
      	WRITE(UTMP,*) CHAR(12)		! Start New Page on Printer
	WRITE(UTMP,*) imgID
	WRITE(UTMP,*) 'ImageWidth=',xlength,'    ','ULcol=',x,'    ','ULrow=',y
      	WRITE(UTMP,*) 'imageType=',trim(layer),'    ','bpp=',bpp,'    ','bitorder=',order,'    ','pixel#1=',pixelUL1
	IF (jsensor /= 4 .and. jsensor /= 5 .and. jsensor /= 6) then 
	  	WRITE(UTMP,*) 'IQ = ',IQ,'       ', 'NIIRS = ', prediirs
	ELSE
	  	WRITE(UTMP,*) 'IQ = ',IQ,'       '
	ENDIF
	WRITE(UTMP,*) 'ImageCodes = ',allcodes,'    Magnification =',xmagmin,'    SensorType = ',jsensor        
	WRITE(UTMP,*) 'NoiseFlag = ',noiseflag,'    NoiseRatio = ',noiseratio,'    NoiseVariance = ',noisevar
	WRITE(UTMP,*) 'MidFreqSlope = ',avgslope, '     LowFreqSlope =',xlowfreqslope,'     Contrast =',contrast 
	IF (jsensor == 3) WRITE (UTMP, *) 'Computed GSD (feet) of scanned film = ', gsd
	IF(wedgeratio > highsmear) then
		WRITE(UTMP, *) 'Smear Detected,  wedgeratio > hismear:   ',wedgeratio,' >',highsmear
		WRITE(UTMP, *) 'SmearMagnitude =',smearmag,' pixels','    SmearDirection = ',smeardir,' degrees'
	ELSE
	    WRITE(UTMP, *) 'No Smear Detected:  wedgeratio=',wedgeratio,' is less than highsmear=',highsmear
	ENDIF
	IF((noiseratio >= detectlevel)) THEN
		WRITE(UTMP, *) 'Noise Filter NOT Applied'
	ELSE
	    WRITE(UTMP, *) 'Noise Filter Applied'
	ENDIF
	WRITE(UTMP,*) ' '
        
!   Print Ring Power values, 'rings' in cycles per pixelwidth 
!   	'ringwidth' computed in RingWedgeQuirks, passed to this routine
!   	'numrings' set to 32 (constant) in IQM routine
!   Print Wedge Power values, wedges in degrees 
!  		'wedgewidth' angle defined in preferences file 
!  ringFilter() & wedgeFilter():  ring&wedge spectra weighted by HVS,scaling, and noise filter (if applicable)
!  ring() & wedge():	unweighted ring & wedge spectra		


	iringcount = -1		! count # of non-dc rings
	numwedges = nint(180. / wedgewidth)   
	firstcentervalue = int (1. + ringwidth / 2.)                                                                                                                
      	fcv = REAL(firstcentervalue) 
      	axy = REAL(max (xlength, ylength) )          		
	WRITE(UTMP,*) 'cycles per           RINGPOWER:                              WEDGEPOWER:'
	WRITE(UTMP,*) 'pixwidth    no filter        filtered       angle      no filter       filtered'
	DO i = 1, 1000
		ang  = 90. - (i-1) * wedgewidth	 
		cpw  = (fcv + (i - 2) * ringwidth) / axy
		IF(i == 1) cpw = 0.
		IF(cpw >= .707107 .and. i > numwedges) then 
			EXIT		! exit DO i=1,1000 loop
		ELSEIF(cpw < .707107 .and. i <= numwedges) then
			WRITE(UTMP, fmt='(F7.5, 2E17.7, F9.2, 2E17.7)') &
				cpw, ring(i-1), ringFilter(i-1), ang, wedge(i), wedgeFilter(i)
			iringcount = iringcount + 1
		ELSEIF(cpw < .707107 .and. i > numwedges) then
			WRITE(UTMP, fmt='(F7.5, 2E17.7)') cpw, ring(i-1), ringFilter(i-1)
			iringcount = iringcount + 1
		ELSEIF(cpw >= .707107 .and. i <= numwedges) then
			WRITE(UTMP, fmt='(41x,F9.2, 2E17.7)') ang, wedge(i), wedgeFilter(i)
		ENDIF
        END DO		
	WRITE(UTMP,fmt='(///)')                                                                                                                            
      
	CALL PLOT(iringcount, numwedges)                                                                                                                             

END SUBROUTINE output  



! *********************************************************************************************************




SUBROUTINE PLOT(iringcount, numwedges)	  
	  
! PLOT RING & WEDGE SPECTRA	
! These are simple line/column plots of Log(power), only using standard Fortran-90,
! to ensure cross-platform compatibility without reams of extra code.
! Easy to change max number of lines or columns in plot, but more involved
! to change labelled increments: .1,.2...7 for ring,   90,70,50...-90 for wedge
! Currently plots the 'filtered spectra'

USE globaldata

CHARACTER(1) :: datum(100), yaxis, xaxis(100), xlabel(100)

INTEGER :: yRowsPerDecade, xColsPerRingWedge 

maxlines = 40	   ! y axis is up to 40 lines
maxcols = 80	   ! x axis is up to 80 columns


DO ispectrum = 1,2	
	WRITE(UTMP,*) CHAR(12)		! Start New Page on Printer
	IF(ispectrum == 1) THEN
		ymax = maxval(ringFilter(1:iringcount))		! do not plot DC at ring 0
		ymin = minval(ringFilter(1:iringcount))
		numpts = iringcount
		xColsPerRingWedge = maxcols / numpts
		xinc = (.1 * xColsPerRingWedge * numpts) / .707107		! # cols in 0.10 cy/pixwidth interval  
		numcols = nint(xinc * 7.07107) + 3 
	ELSE
		ymax = maxval(wedgeFilter(1:numwedges))
		ymin = minval(wedgeFilter(1:numwedges))
		numpts = numwedges
		xColsPerRingWedge = maxcols / numpts
		xinc = (20. * xColsPerRingWedge) / wedgewidth		! # cols in 20 degree interval 	
		numcols = nint(xinc * 9.) + 3
	ENDIF
	
	ii = 1
	IF(int(ymax) < 1 ) ii = 0
	yy = LOG10(ymax)
	ymaxDecade = 10.**(int(yy)+ii)		! decade magnitude value for top of y axis

	ii = 0
	IF(int(ymin) < 1 ) ii = -1
	yy = LOG10(ymin)
	yminDecade = 10.**(int(yy)+ii)		! decade magnitude value for bottom of y axis
	
	yRowsPerDecade = maxlines / int(LOG10((ymaxDecade+.01*ymaxDecade)/yminDecade))
	
! Determine locations of ticks along x axis, every 0.1 cy/pixelwidth
! This method can result in slightly nonconstant 0.1 intervals
! but it evens-out by the time 0.7 cy/pixwidth is reached.
! If intervals were to be made constant, and true exact interval has fractional part
! near 0.5, then interval size error would accumulate
  	xaxis = ' '
  	xaxis(1:numcols+3) = '-'
	xlabel = ' '
  	n = 0

! Following xaxis labeling code could be shortened via 'internal write of string' approach	
	IF(ispectrum == 1) THEN	
 		DO jz = 1, 7			! ring cy/pixwidth labels: .1, .2, ... .7
 			z = (jz-1) * xinc
  			n = n+1  
			i = NINT(z) + 1
			xaxis(i) = '|'
			IF(n==1) xlabel(i)='0' 
			IF(n==2) xlabel(i)='1'
			IF(n==3) xlabel(i)='2'
			IF(n==4) xlabel(i)='3'
			IF(n==5) xlabel(i)='4'
			IF(n==6) xlabel(i)='5'
			IF(n==7) xlabel(i)='6'
			IF(n==8) xlabel(i)='7'
			xlabel(i-1) = '.'
  		END DO	
	ELSE
		
		inc = nint(xinc)
		DO n = 0, 9				! wedge degree labels: 90, 70, 50, ... -70
			i = n * inc + 1
			xaxis(i) = '|'
			IF(n==0) THEN
				xlabel(i)='9';  xlabel(i+1)='0'
			ELSEIF(n==1) THEN
				xlabel(i)='7';  xlabel(i+1)='0'
			ELSEIF(n==2) THEN
				xlabel(i)='5';  xlabel(i+1)='0'
			ELSEIF(n==3) THEN
				xlabel(i)='3';  xlabel(i+1)='0'
			ELSEIF(n==4) THEN
				xlabel(i)='1';  xlabel(i+1)='0'
			ELSEIF(n==5) THEN
				xlabel(i-1)='-';  xlabel(i)='1';  xlabel(i+1)='0'
			ELSEIF(n==6) THEN 
				xlabel(i-1)='-';  xlabel(i)='3';  xlabel(i+1)='0'
			ELSEIF(n==7) THEN
				xlabel(i-1)='-';  xlabel(i)='5';  xlabel(i+1)='0'
			ELSEIF(n==8) THEN
				xlabel(i-1)='-';  xlabel(i)='7';  xlabel(i+1)='0'
			ELSEIF(n==9) THEN
				xlabel(i-1)='-';  xlabel(i)='9';  xlabel(i+1)='0'
			ENDIF
  		END DO	

	ENDIF
		

! For each line, which corresponds to a Log(power) value, find location(s) along x axis,
! where spectrum values correspond to this line; store an asterisk at the column locations
! then write the entire line, where a column is either blank or *.
  	idec = 0
  	DO j = maxlines, 0, -1	
		datum = ' '
		yaxis = '|'
		ylabel = -1.
	
		DO k=0,10
			IF( (k*yRowsPerDecade) == j) THEN
				yaxis='-' 
				ylabel = ymaxDecade / 10.**idec
				idec = idec + 1
			ENDIF
		END DO
	
		DO i = 1, numpts
			k = xColsPerRingWedge * i
			IF(ispectrum == 1) THEN
				line = nint(LOG10(ringFilter(i)/yminDecade) * yRowsPerDecade)	! line up from Xaxis

			ELSE
				line = nint(LOG10(wedgeFilter(i)/yminDecade) * yRowsPerDecade)

			ENDIF
			IF(line == j) datum(k) = '*'
		END DO		
   
   		IF(ylabel < 0.) THEN
			WRITE(UTMP,fmt='(7x,A1,1x,100A1)') yaxis,(datum(n), n=1,numcols)	
		ELSE
			WRITE(UTMP,fmt='(E7.1,A1,1x,100A1)') ylabel,yaxis,(datum(n), n=1,numcols)
		ENDIF	

   
    END DO

	IF(ispectrum == 1) THEN
	  	WRITE(UTMP, fmt='(7x,100A1)')  '-',  (xaxis(n), n=1,numcols)
	  	WRITE(UTMP, fmt='(8x,100A1)')    (xlabel(n), n=1,numcols)

	  	WRITE(UTMP, *) '             cycles per pixelwidth'
 	ELSE
		WRITE(UTMP, fmt='(8x,100A1)') '-',  (xaxis(n), n=1,numcols)
	  	WRITE(UTMP, fmt='(9x,100A1)')   (xlabel(n), n=1,numcols)
		WRITE(UTMP, *) '             wedge angle (degrees)'
	ENDIF
	  
	  WRITE(UTMP, fmt='(//)')																		


END DO

END SUBROUTINE plot

