      SUBROUTINE power2 (imgwidth, npower) 
                                                                                                                                  
!       Image Quality Measure (IQM) Program                                                                                       
!       Copyright, THE MITRE Corporation 1992 - 2007                                                                                
!       see Data Rights Notice in HELP SUBROUTINE                                                                             
                                                                                                                                  
!       This subroutine:                                                                                                          
!       Determines if image is power-of-2 size in "imgwidth" direction
! 		if yes:  returns "npower", where:   imgwidth = 2**npower
!       if no:   returns  -1                                                                  
!		Starting with IQM v6.0, power-of-2 size image is no longer needed
!		for FFT processing, but knowledge of image size & shape is still needed by IQM 

!		if npower >= 15,  imgwidth >= 32768,  then FFT may fail and/or
!		integer multiplies in code, e.g. xlength**2, may exceed largest valid integer

      npower = - 1 
      IF (IAND(imgwidth, imgwidth-1) == 0) npower = nint(log10(REAL(imgwidth)) / log10(2.))
       
      END SUBROUTINE power2   
	  
