 SUBROUTINE PRIMECHECK (iwidth, iprimeflag)
 
!       Image Quality Measure (IQM) Program                                                                                       
!       Copyright, THE MITRE Corporation 1992 - 2007                                                                                
!       see Data Rights Notice in HELP SUBROUTINE                                                                             

! FFT compute time is considerably longer if image width = prime number
! so notify user when prime occurs:
! if input iwidth is prime, output iprimeflag = 1
! But if width is sufficiently small, then even if it is prime
! the FFT time will not be too long, so skip 'small' primes.
! e.g., for prime width=401, compute time=15sec on 450Mhz machine
	
 IF(iwidth < 702) RETURN	
 iprimeflag = 1
 jsqrt = INT (SQRT(REAL(iwidth))) ! algorithm kernal derived from 1995 code of B.Barney, R.Ng, W.Sze
  DO k = 2, jsqrt			 
 	IF (MOD(iwidth,k) == 0) THEN	
              iprimeflag = 0
              EXIT	! exit DO 
        ENDIF
  END DO        
  
  IF(iprimeflag == 1) PRINT*, iwidth, ' IMAGE WIDTH IS PRIME NUMBER, EXPECT LONG COMPUTE TIME'
  
  END SUBROUTINE PRIMECHECK
  